#==================================================================================================================================================== 

# MATERIA: RCC0219 - Probabilidade e Estatística Aplicadas à Contabilidade I (2018)
# PROFESSOR: Davi Rogério de Moura Costa

# CURSO: Introdução ao R
# SCRIPT: Importando DB e manipulando dados

#====================================================================================================================================================


# Packages utilizados                      ----
install.packages("readxl")
# install.packages("xlsx")
# install.packages("openxlsx")
install.packages("dplyr")
install.packages("tidyr")
install.packages("psych")
install.packages("ggplot2")
install.packages("stringr")

# Librarys Utilizadas                      ----
library(readxl)
# library(xlsx)
# library(openxlsx)
library(dplyr)
library(tidyr)
library(psych)
library(ggplot2)
library(stringr)

# Carregando base                          ----

CoopAgro2006NumEstab <-  read_xlsx("C:/Users/rtheodoro/Desktop/Curso R - Ricardo/Cooperados por Municipio - Censo Agro_2006.xlsx", sheet=1, skip=7)
View(CoopAgro2006NumEstab)
CoopAgro2006AreaEstab <-  read_xlsx("C:/Users/rtheodoro/Desktop/Curso R - Ricardo/Cooperados por Municipio - Censo Agro_2006.xlsx", sheet=2, skip=7)
View(CoopAgro2006AreaEstab)

# CoopAgro2006NumEstab <-  read_xlsx("C:/Users/rtheodoro/Desktop/Curso R - Ricardo/Cooperados por Municipio - Censo Agro_2006.xlsx", sheetIndex=1, startRow=8)
# View(CoopAgro2006NumEstab)
# CoopAgro2006AreaEstab <-  read.xlsx("C:/Users/rtheodoro/Desktop/Curso R - Ricardo/Cooperados por Municipio - Censo Agro_2006.xlsx", sheetIndex = 2, startRow=8)
# View(CoopAgro2006AreaEstab)


# Tratamento da Base                       ----

# Renomeando Colunas
names(CoopAgro2006NumEstab)[1:9] <- c("Cidade","Orientacao Tecnica","Origem O.T.","Total","Associado","Coop","Classe","CoopeClasse","N.Associado")
names(CoopAgro2006AreaEstab)[1:9] <- c("Cidade","Orientacao Tecnica","Origem O.T.","Total","Associado","Coop","Classe","CoopeClasse","N.Associado")

# Separando Pais e Estados em novo DB
CoopAgro2006NumEstabPais = data.frame(CoopAgro2006NumEstab[1,c("Cidade","Orientacao Tecnica","Origem O.T.","Total","Associado","Coop","Classe","CoopeClasse","N.Associado")])
CoopAgro2006NumEstabEstado = data.frame(CoopAgro2006NumEstab[2:28,c("Cidade","Orientacao Tecnica","Origem O.T.","Total","Associado","Coop","Classe","CoopeClasse","N.Associado")])

CoopAgro2006AreaEstabPais = data.frame(CoopAgro2006NumEstab[1,c("Cidade","Orientacao Tecnica","Origem O.T.","Total","Associado","Coop","Classe","CoopeClasse","N.Associado")])
CoopAgro2006AreaEstabEstado = data.frame(CoopAgro2006NumEstab[2:28,c("Cidade","Orientacao Tecnica","Origem O.T.","Total","Associado","Coop","Classe","CoopeClasse","N.Associado")])

# Removendo Pais, Estados e Linha do IBGE do DF original
CoopAgro2006NumEstab <- CoopAgro2006NumEstab[-1:-28, ]  # Remoção da linha 1 até a linha 28
CoopAgro2006AreaEstab <- CoopAgro2006AreaEstab[-1:-28, ]# Remoção da linha 1 até a linha 28
CoopAgro2006AreaEstab <- subset(CoopAgro2006AreaEstab, Cidade!="Fonte: IBGE - Censo Agropecuário")
CoopAgro2006NumEstab <- subset(CoopAgro2006NumEstab, Cidade!="Fonte: IBGE - Censo Agropecuário")


# Separando o Estado em nova coluna
CoopAgro2006NumEstab$Estado <- str_sub(CoopAgro2006NumEstab$Cidade, start = -4) # Cria a coluna Estado
CoopAgro2006NumEstab$Cidade <- str_sub(CoopAgro2006NumEstab$Cidade, end = -6) # Retira o estado da coluna Cidade
CoopAgro2006NumEstab$Estado <- str_replace_all(CoopAgro2006NumEstab$Estado, fixed("("), "") # Remove parenteses do lado esquerdo
CoopAgro2006NumEstab$Estado <- str_replace_all(CoopAgro2006NumEstab$Estado, fixed(")"), "") # Remove parenteses do lado direito

CoopAgro2006AreaEstab$Estado <- str_sub(CoopAgro2006AreaEstab$Cidade, start = -4) # Cria a coluna Estado
CoopAgro2006AreaEstab$Cidade <- str_sub(CoopAgro2006AreaEstab$Cidade, end = -6) # Retira o estado da coluna Cidade
CoopAgro2006AreaEstab$Estado <- str_replace_all(CoopAgro2006AreaEstab$Estado, fixed("("), "") # Remove parenteses do lado esquerdo
CoopAgro2006AreaEstab$Estado <- str_replace_all(CoopAgro2006AreaEstab$Estado, fixed(")"), "") # Remove parenteses do lado direito

# Movendo a coluna Estado
CoopAgro2006NumEstab <- CoopAgro2006NumEstab %>% select("Cidade","Estado", everything())
CoopAgro2006AreaEstab <- CoopAgro2006AreaEstab %>% select("Cidade","Estado", everything())

# Criando coluna
CoopAgro2006NumEstab$Pais <- c("Brasil")

# Alterando célula em uma coluna
CoopAgro2006NumEstab[1,11] <- "BRASIL" # Altera o dado da linha 1 e coluna 11

# Removeno coluna
CoopAgro2006NumEstab$Pais <- NULL

# Filtrando Informações
CoopAgro2006NumEstab %>% filter(Classe==1) %>% select(Cidade,Estado) # Seleciona cidades com Classe 1 e exibe Cidade e Estado
CoopAgro2006NumEstab %>% filter(Classe %in% c(1, 2)) %>% select(Cidade,Estado) # Seleciona cidades com Classe 1 e 2, e exibe Cidade e Estado 
CoopAgro2006NumEstab %>% filter(Classe %in% c(1, 2) & Estado=="SP") %>% select(Cidade,Estado) # Seleciona cidades com Classe 1 e 2, Estado SP e exibe Cidade e Estado

# Substituindo valores
CoopAgro2006NumEstab$Associado[which(CoopAgro2006NumEstab$Associado == "-")] <- 0
CoopAgro2006NumEstab$Coop[which(CoopAgro2006NumEstab$Coop == "-")] <- 0
CoopAgro2006NumEstab$Classe[which(CoopAgro2006NumEstab$Classe == "-")] <- 0
CoopAgro2006NumEstab$CoopeClasse[which(CoopAgro2006NumEstab$CoopeClasse == "-")] <- 0
CoopAgro2006NumEstab$`N.Associado`[which(CoopAgro2006NumEstab$`N.Associado` == "-")] <- 0

CoopAgro2006AreaEstab$Associado[which(CoopAgro2006AreaEstab$Associado == "-")] <- 0
CoopAgro2006AreaEstab$Coop[which(CoopAgro2006AreaEstab$Coop == "-")] <- 0
CoopAgro2006AreaEstab$Classe[which(CoopAgro2006AreaEstab$Classe == "-")] <- 0
CoopAgro2006AreaEstab$CoopeClasse[which(CoopAgro2006AreaEstab$CoopeClasse == "-")] <- 0
CoopAgro2006AreaEstab$`N.Associado`[which(CoopAgro2006AreaEstab$`N.Associado` == "-")] <- 0

# Transformando Colunas em Números
CoopAgro2006NumEstab$Associado <- as.numeric(CoopAgro2006NumEstab$Associado)
CoopAgro2006NumEstab$Coop <- as.numeric(CoopAgro2006NumEstab$Coop)
CoopAgro2006NumEstab$Classe <- as.numeric(CoopAgro2006NumEstab$Classe)
CoopAgro2006NumEstab$CoopeClasse <- as.numeric(CoopAgro2006NumEstab$CoopeClasse)
CoopAgro2006NumEstab$`N.Associado` <- as.numeric(CoopAgro2006NumEstab$`N.Associado`)

CoopAgro2006AreaEstab$Associado <- as.numeric(CoopAgro2006AreaEstab$Associado)
CoopAgro2006AreaEstab$Coop <- as.numeric(CoopAgro2006AreaEstab$Coop)
CoopAgro2006AreaEstab$Classe <- as.numeric(CoopAgro2006AreaEstab$Classe)
CoopAgro2006AreaEstab$CoopeClasse <- as.numeric(CoopAgro2006AreaEstab$CoopeClasse)
CoopAgro2006AreaEstab$`N.Associado` <- as.numeric(CoopAgro2006AreaEstab$`N.Associado`)


# Adicionando Código de Municípios (IBGE)

# Importando .CSV com códigos do IBGE
cod_mun <- read.csv("C:/Users/rtheodoro/Desktop/Curso R - Ricardo/cod_mun.csv",header=T,sep=";")

# Mesclando os data.frames (primeiro é preciso deixar os campos iguais)

# Deixando tudo maiúsculo
CoopAgro2006AreaEstab$Cidade <- str_to_upper(CoopAgro2006AreaEstab$Cidade)
CoopAgro2006NumEstab$Cidade <- str_to_upper(CoopAgro2006NumEstab$Cidade)

# Removendo acentos
CoopAgro2006AreaEstab$Cidade <- chartr("ÃÁÂÉÊÍÓÔÕÚÜÇ","AAAEEIOOOUUC", CoopAgro2006AreaEstab$Cidade)
CoopAgro2006NumEstab$Cidade <- chartr("ÃÁÂÉÊÍÓÔÕÚÜÇ","AAAEEIOOOUUC", CoopAgro2006NumEstab$Cidade)

CoopAgro2006AreaEstab$Cidade <- gsub("D'O", "DO O",CoopAgro2006AreaEstab$Cidade)
CoopAgro2006AreaEstab$Cidade <- gsub("D'A", "DA A",CoopAgro2006AreaEstab$Cidade)
CoopAgro2006AreaEstab$Cidade <- gsub("-", " ",CoopAgro2006AreaEstab$Cidade)

CoopAgro2006NumEstab$Cidade <- gsub("D'O", "DO O",CoopAgro2006NumEstab$Cidade)
CoopAgro2006NumEstab$Cidade <- gsub("D'A", "DA A",CoopAgro2006NumEstab$Cidade)
CoopAgro2006NumEstab$Cidade <- gsub("-", " ",CoopAgro2006NumEstab$Cidade)


# Usando função MERGE
cod_mun$X <- NULL # Remove coluna desnecessária

CoopAgro2006AreaEstab <- merge(CoopAgro2006AreaEstab,cod_mun, by.x=c("Cidade","Estado"), by.y=c("municipio","uf"))
CoopAgro2006NumEstab <- merge(CoopAgro2006NumEstab,cod_mun, by.x=c("Cidade","Estado"), by.y=c("municipio","uf"))

setdiff(c(cod_mun$municipio),c(CoopAgro2006AreaEstab$Cidade)) # Verifica diferenças entre DF

# Renomenado novas colunas
colnames(CoopAgro2006NumEstab) # Verifica número da coluna
colnames(CoopAgro2006NumEstab)[11] <- c("cod_IBGE_uf")
colnames(CoopAgro2006NumEstab)[12] <- c("cod_IBGE_mun")

# Exploracao dos dados                     ----
summary(CoopAgro2006NumEstab)             # Min, 1Q, Med, Méd, 3Q, Max
describe(CoopAgro2006NumEstab$Total)      # Pacote Psych, fornece estatística descritiva

# Criando variável e somando linhas
CoopAgro2006NumEstab <- transform(CoopAgro2006NumEstab, Prop_Coop=((CoopAgro2006NumEstab$Coop+CoopAgro2006NumEstab$CoopeClasse)/CoopAgro2006NumEstab$Total)*100)

# Criando 5 grupos de acordo com a proporção, 1=(0<20), 2=(>=20 e <40),3=(>=40 e <60),4=(>=60 e <80),5=(>=80 e <=100)
CoopAgro2006NumEstab$Grupo_prop_coop <- c(0)   # Cria a coluna

i <- 1 

for (i in 1:nrow(CoopAgro2006NumEstab)){
  if (CoopAgro2006NumEstab[i,"Prop_Coop"]<20){
     CoopAgro2006NumEstab[i,"Grupo_prop_coop"] <- 1
  } else if (CoopAgro2006NumEstab[i,"Prop_Coop"]>=20 && CoopAgro2006NumEstab[i,"Prop_Coop"]<40 ){
    CoopAgro2006NumEstab[i,"Grupo_prop_coop"] <- 2
  } else if (CoopAgro2006NumEstab[i,"Prop_Coop"]>=40 && CoopAgro2006NumEstab[i,"Prop_Coop"]<60 ){
    CoopAgro2006NumEstab[i,"Grupo_prop_coop"] <- 3
  } else if (CoopAgro2006NumEstab[i,"Prop_Coop"]>=60 && CoopAgro2006NumEstab[i,"Prop_Coop"]<80 ){
    CoopAgro2006NumEstab[i,"Grupo_prop_coop"] <- 4
  } else {
    CoopAgro2006NumEstab[i,"Grupo_prop_coop"] <- 5
  }
} # Atribui os valores para a coluna criada de acordo com as características

# Calculando Frequencia Absoluta por Estado
CoopAgro2006NumEstab<-CoopAgro2006NumEstab %>% 
  group_by(cod_IBGE_uf) %>%                  # Agrupa por estado
  mutate(Freq_abs_UF=Coop+CoopeClasse)  

# Calculando Frequencia Relativa por Estado com vinculo a coop
CoopAgro2006NumEstab<-CoopAgro2006NumEstab %>% 
  group_by(cod_IBGE_uf) %>%         # Agrupa por estado
  mutate(Freq_rel_UF=(Freq_abs_UF)/(sum(Freq_abs_UF))) %>%  # Cada Estado = 100%
  mutate(Freq_rel_UF=round(Freq_rel_UF*100, 2))

# Calculando Frequencia Relativa Brasil
total <- sum(CoopAgro2006NumEstab$Freq_abs_UF)
CoopAgro2006NumEstab<-CoopAgro2006NumEstab %>% 
  mutate(Freq_rel_Total=(Freq_abs_UF)/total) %>%  # Brasil = 100%
  mutate(Freq_rel_Total=round(Freq_rel_Total*100, 2))


# Descreve a Estatística descritiva de determinadas colunas, agrupada por alguma categoria
describeBy(CoopAgro2006NumEstab[,c('Prop_Coop','Freq_abs_UF')],group=CoopAgro2006NumEstab$Estado)

# Criando Histograma                       ----

# Frequencia dos grupos
freq_grupo <- table(CoopAgro2006NumEstab$Grupo_prop_coop) # Freq Absoluta
freq_rel_grupo <- data.frame(100*prop.table(freq_grupo)) # Frequencia Relativa de cada grupo
freq_rel_grupo$Freq

histograma <- hist(CoopAgro2006NumEstab$Grupo_prop_coop, col="lightblue", border="black", prob=FALSE, main="Histograma: Grupos de Proporção de Cooperativas", ylab="Frequência Absoluta", xlab="Grupos", ylim=c(0,4500), label= paste(round(freq_rel_grupo$Freq,2),"%") , breaks = c(0,seq(1,5,1))) # Por densidade prob=TRUE
xfit<-seq(min(CoopAgro2006NumEstab$Grupo_prop_coop),max(CoopAgro2006NumEstab$Grupo_prop_coop))
yfit<-dnorm(xfit,mean=mean(CoopAgro2006NumEstab$Grupo_prop_coop),sd=sd(CoopAgro2006NumEstab$Grupo_prop_coop))
yfit <- yfit*diff(histograma$mids[1:2])*length(CoopAgro2006NumEstab$Grupo_prop_coop)
lines(xfit, yfit, col="pink", lwd=5) # Curva


# Criando Gráficos                         ----

## Freq. Relativa Total (por estado)
ggplot(CoopAgro2006NumEstab, aes(y=CoopAgro2006NumEstab$Freq_rel_Total, x=CoopAgro2006NumEstab$Estado)) +
  geom_bar(stat="identity", col="lightblue") +  labs(title = "Frequência Relativa por Estado", x="Estados", y="Frequência Relativa", caption = "Elaborado pelo autor")+
  theme(plot.caption = element_text(hjust = 0))  # Posiciona CAPTION a direita (0.5=Centro)
  

## Freq. Abs. por UF
ggplot(CoopAgro2006NumEstab, aes(y=CoopAgro2006NumEstab$Freq_abs_UF, x=CoopAgro2006NumEstab$Estado)) +
  geom_bar(stat="identity", colour="lightgreen") + labs(title = "Frequência Absoluta por Estado", x="Estados", y="Frequancia Absoluta", scale_fill_hue('Legenda'))

    ####### Inserindo cores nos gráficos
    library(RColorBrewer)
    display.brewer.all() # Pacote RColorBrewer, esse comando exibe paleta de cores do R
    color <- colorRampPalette(c("yellow", "green")) # Comando para gerar Degrade, do amarelo ao verde
    color2 <- colorRampPalette(c("lightblue", "darkgreen"))

## Gráfico com boxplot, paleta de cores  (color(5), porque são 5 boxplots) e tema pronto
ggplot(CoopAgro2006NumEstab, aes(x=reorder(Grupo_prop_coop,Prop_Coop), y=Prop_Coop,fill=Grupo_prop_coop))+
  geom_boxplot(fill=color(5)) + labs(title = "Box Plot", x="Grupos de Cooperativas por proporção", y="Proporção de Cooperativas")+ 
  theme_bw() # Existem outros temas, como classic, light, dark..


## Gráfico com histograma (outra maneira)
ggplot(CoopAgro2006NumEstab, aes(x=Grupo_prop_coop))+
  geom_histogram(fill=color2(5), binwidth = 1,inherit.aes = TRUE,position = "stack")+
  labs(title = "Histograma", x="Grupos", y="Quantidade", scale_fill_hue('Legenda')) +
  theme(panel.background=element_rect(fill="white"), panel.grid.major=element_line(colour="darkgrey", linetype ="dashed"))



